﻿@using System.Web.Helpers;

@* Remove this section if you are using bundling *@
@section Scripts {
    <script src="~/Scripts/jquery.validate.min.js"></script>
    <script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
}

@{
    Layout = "~/_SiteLayout.cshtml";
    Page.Title = "Log in";

    // Initialize general page variables
    var username = "";
    var password = "";

    var returnUrl = Request.QueryString["ReturnUrl"];
    if (returnUrl.IsEmpty()) {
        // Some external login providers always require a return URL value
        returnUrl = Href("~/");
    }

    // Setup validation
    Validation.RequireField("username", "You must specify an username address.");
    Validation.RequireField("password", "You must specify a password.");
    Validation.Add("password",
        Validator.StringLength(
            maxLength: Int32.MaxValue,
            minLength: 8,
            errorMessage: "Password must be at least 8 characters"));

    // If this is a POST request, validate and process data
    if (IsPost) {
        AntiForgery.Validate();
        // is this an external login request?
        if (Validation.IsValid()) {
            username = Request.Form["username"];
            password = Request.Form["password"];

            // Attempt to log in using provided credentials
            var db = Database.Open("webdev");
//          var salt = db.QueryValue("SELECT Salt FROM Accounts WHERE (LOWER(Email) = LOWER(@0)) OR (LOWER(Name) = LOWER(@0))", username);
            var salt = db.QueryValue("SELECT Salt FROM Accounts WHERE LOWER(Email) = LOWER(@0)", username);

            if(!string.IsNullOrEmpty(salt)) {
                var enc_pass = Crypto.SHA256(password + salt);
//              var user = db.QueryValue("SELECT Email FROM Accounts WHERE (LOWER(Email) = LOWER(@0) OR LOWER(Name) = LOWER(@0) ) AND Password = @1", username, enc_pass);            
                var user = db.QueryValue("SELECT Email FROM Accounts WHERE LOWER(Email) = LOWER(@0) AND Password = @1", username, enc_pass);

            
                if (!string.IsNullOrEmpty(user)) {
                    Session["username"] = user;
                    Context.RedirectLocal("~/Profile");
                } else {
                    ModelState.AddFormError("The password provided is incorrect.");
                }

            } else {
                ModelState.AddFormError("Unknown email/user.");
            }
        }
    }
}

<hgroup class="title">
    <h1>@Page.Title.</h1>
</hgroup>

<h2>Use a local account to log in.</h2>
<form method="post">
    @AntiForgery.GetHtml()
    @* If one or more validation errors exist, show an error *@
    @Html.ValidationSummary("Log in was unsuccessful. Please correct the errors and try again.", excludeFieldErrors: true, htmlAttributes: null)

    <fieldset>
        <legend>Log in to Your Account</legend>
        <ol>
            <li class="username">
                <label for="username" @if (!ModelState.IsValidField("username")) {<text>class="error-label"</text>}>Email address</label>
                <input type="text" id="username" name="username" value="@username" @Validation.For("username")/>
                @* Write any user name validation errors to the page *@
                @Html.ValidationMessage("username")
            </li>
            <li class="password">
                <label for="password" @if (!ModelState.IsValidField("password")) {<text>class="error-label"</text>}>Password</label>
                <input type="password" id="password" name="password" @Validation.For("password")/>
                @* Write any password validation errors to the page *@
                @Html.ValidationMessage("password")
            </li>
        </ol>
        <input type="submit" value="Log in" />
    </fieldset>
</form>
<p>
    <a href="~/Account/Register">Don't have a Account?</a>
    <a href="~/Account/ForgotPassword">Did you forget your password?</a>
</p>
